/**
 * Created by hideaki on 2014/12/03.
 */

this.SuiteLibsJs = this.SuiteLibsJs||{};

/**
 * Score+用JSライブラリクラス
 */
(function(window) {
    var SuiteScorePlusLib = function() {
        this.thisName = "SuiteScorePlusLib";
    }

    //継承なし
    var p = SuiteScorePlusLib.prototype;

    p.url = "";
    p.type = "";
    p.user = "";
    p.group = "";
    p.session = 0;
    p.content_id = "";
    p.content_url = "";
    p.content_title = "";
    p.ver = 1.0;

    p._localStorageCtrl;
    p.PROGRESS = "LwSuite_progress";

    /***
     * 初期設定処理
     * @param url 送信先URL
     * @param type タイプ（製品とかコンテンツ種類）"STORM"
     * @param group グループ識別ID（顧客）
     * @param user ユーザーID （※空文字の場合、Getパラメータ「u」から取得）
     * @param id コンテンツID
     * @param url コンテンツURL （※空文字の場合、location情報から取得）
     * @param title コンテンツタイトル （※空文字の場合、document.title取得）
     */
    p.init = function(url, type, group, user, content_id, content_url, content_title){
        this.url = url;
        this.type = type;
        this.group = group;
        //ユーザーIDが空文字の場合は、Getパラメータ「u」から取得
        if(user == ""){
            this.user = this.getUserParameter();
        }else{
            this.user = user;
        }

        this.content_id = content_id;
        //コンテンツURLが空文字の場合は、locationから取得
        if(content_url == ""){
            this.content_url = this.getSelfUrl();
        }else{
            this.content_url = content_url;
        }
        //タイトル文字列が空文字の場合はドキュメントタイトルをセット
        if(content_title == ""){
            this.content_title = document.title
        }else{
            this.content_title = content_title;
        }

        this.session = new Date().getTime();

        //内部保存でデータ操作用クラスインスタンス生成
        this._localStorageCtrl = new SuiteLibsJs.LocalStorageController();
        this._localStorageCtrl.init(this.content_url, this.user);
    }
    /***
     * 自分のURL文字列を取得（ハッシュやパラメータなし）
     * スマホ版PlayerURLの場合はPC版PlayerのURLを返す
     * @returns {string}
     */
    p.getSelfUrl = function(){
        var contentUrl_temp = [location.protocol,"//",location.host,location.pathname].join("");
        var contentUrl_list = contentUrl_temp.split("/");
        //スマホ版PlayerURLの場合はPC版PlayerのURLを返す
        if(contentUrl_list[contentUrl_list.length-2] == "m" || contentUrl_list[contentUrl_list.length-2] == "mobile"){
            contentUrl_list.splice(contentUrl_list.length-2, 1);
        }
        if(contentUrl_list[contentUrl_list.length-1] == "tablet.html"){
            contentUrl_list[contentUrl_list.length-1] = "index.html";
        }
        var contentUrl = contentUrl_list.join("/");
        return contentUrl;
    }

    /***
     *  getパラメータをオブジェクトで取得
     * @returns {*}
     * @private
     */
    p._getRequest = function() {
        if (location.search.length > 1) {
            var get = new Object();
            var ret = location.search.substr(1).split("&");
            for (var i = 0; i < ret.length; i++) {
                var r = ret[i].split("=");
                get[r[0]] = r[1];
            }
            return get;
        } else {
            return false;
        }
    }
    /***
     * getパラメータ「u」の値を取得する
     * @returns {*}
     */
    p.getUserParameter = function(){
        var getObj = this._getRequest();
        var u = getObj["u"];
        if(u != undefined && u != null){
            return u;
        }else{
            return "";
        }
    }

    /***
     * コンテンツの進捗セット
     * @param progress 閲覧位置（10秒単位の値） 整数
     * @param total コンテンツの総再生時間（秒数）　整数
     * @param value 単位値（秒数） 設定なしの場合10　整数
     */
    p.setProgress = function(progress, total, value){
        //進捗情報を保存
        try{
            this._localStorageCtrl.setDataForContentUser(this.PROGRESS, progress);
        }catch (e){}

        //value設定値なしの場合、10
        if(value == undefined || value == null){
            value = 10;
        }

        var value_tmp = value;
        //最後まで再生した場合
        if(progress == total){
            //最後まで再生した場合
            value_tmp = progress % value;
            //割り切れた場合はvalue値をセット
            if(value_tmp == 0){
                value_tmp = value;
            }
        }
        //JSON化してURLsafeのbase64データにして送信（base64はサイズ33%増加）
        //http://ドメイン or IP/＜データ＞
        //で送信予定 ・改ざん防止、ログファイル上の1行保証（改行が入らない）
        var obj = {};
        obj.type = this.type;
        obj.action = "play";
        obj.user_id = this.user;
        obj.group_id = this.group;
        obj.session_id = this.session;
        obj.id = this.content_id;
        obj.url = this.content_url;
        obj.title = this.content_title;
        obj.progress = progress;
        obj.total = total;
        obj.value = value_tmp;
        obj.time = new Date().getTime();
        obj.ver = this.ver;

        var json = JSON.stringify(obj);

        //URL SafeなBase64 encode
        var base64str = Base64.encodeURI(json);

        var sendUrl = this.url;
        var i = sendUrl.lastIndexOf("/");
        if(i == sendUrl.length - 1){
            sendUrl += base64str;
        }else{
            sendUrl += "/" + base64str;
        }

        //データ送信
        var sendAgent = new SuiteLibsJs.SendAgent();
        sendAgent.sendGet(sendUrl);
    }
    /***
     * 前回の進捗情報取得
     * @returns {string} 内部で取得できなかった場合、空文字が返る
     */
    p.getPrevProgress = function(){
        var value = "";
        //進捗情報を取得
        try{
            value = this._localStorageCtrl.getDataForContentUser(this.PROGRESS);
        }catch (e){}

        return value;
    }

    SuiteLibsJs.SuiteScorePlusLib = SuiteScorePlusLib;
}(window));